%if 0%{?rhel} && 0%{?rhel} < 5
%{!?python_sitelib: %global python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}
%{!?python_version: %global python_version %(%{__python} -c "import sys ; print sys.version[:3]")}
%endif

%{!?python3_version: %global python3_version %(%{__python3} -c "import sys; sys.stdout.write(sys.version[:3])")}

%if 0%{?fedora}
%global with_python3 1
%global with_doc 1
%global with_extras 1
%else
%global with_python3 0
%global with_doc 0
%global with_extras 0
%endif

%global with_optionals 0

# disable debuginfo
%define debug_package %{nil}
%define pkgname anyconfig

Name:           python-%{pkgname}
Version:        0.4.0
Release:        1%{?dist}
Summary:        Generic access to configuration files in some formats
Group:          Development/Libraries
License:        MIT
URL:            https://github.com/ssato/%{name}
#Source0:        https://github.com/ssato/%{name}/tarball/master/%{name}-%{version}.tar.gz
Source0:        %{pkgname}-%{version}.tar.gz
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch
BuildRequires:  python-devel
BuildRequires:  python-setuptools
%if 0%{?with_doc}
BuildRequires:  python-docutils
BuildRequires:  python-sphinx
BuildRequires:  make
%endif
Requires:       PyYAML
Requires:       python-setuptools
%if %{?rhel}%{!?rhel:0} == 5
Requires:       python-simplejson
%endif
%if 0%{?with_extras}
Requires:       python-jinja2
Requires:       python-jsonschema
%endif
%if 0%{?with_optionals}
Requires:       python-bson
Requires:       python-configobj
Requires:       python-msgpack
Requires:       python-toml
%endif
%if 0%{?with_python3}
BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
%endif

%description
Python library to provide generic access to configuration files in some
formats such like INI, JSON and YAML.

%if 0%{?with_python3}
%package -n python3-%{pkgname}
Summary:        Generic access to configuration files in some formats
Group:          Development/Libraries
Requires:       python3-PyYAML
Requires:       python3-setuptools
%if 0%{?with_extras}
Requires:       python3-jinja2
Requires:       python3-jsonschema
%endif
%if 0%{?with_optionals}
Requires:       python3-msgpack
Requires:       python3-bson
Requires:       python3-configobj
Requires:       python3-msgpack
Requires:       python3-toml
%endif

%description -n python3-%{pkgname}
Python library to provide generic access to configuration files in some
formats such like INI, JSON and YAML.
%endif

%prep
%setup -q -n %{pkgname}-%{version}

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
%endif

%build
%{__python} setup.py build
%if 0%{?with_doc}
make -C docs/ html
%endif

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py build
popd
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if 0%{?with_python3}
pushd %{py3dir}
%{__python3} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
mv $RPM_BUILD_ROOT%{_bindir}/anyconfig_cli $RPM_BUILD_ROOT%{_bindir}/py3anyconfig_cli
# TODO: It does not look working well:
#chmod +x $RPM_BUILD_ROOT%{_bindir}/py3anyconfig_cli
popd
%endif
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%doc README.rst
%if 0%{?with_doc}
%doc docs/build/html
%endif
%{python_sitelib}/*
%{_bindir}/anyconfig_cli
%{_mandir}/*/*

%if 0%{?with_python3}
%files -n python3-%{pkgname}
%defattr(644,root,root,755)
%doc README.rst
%{python3_sitelib}/*
%attr(755,root,root) %{_bindir}/py3anyconfig_cli
%endif

%changelog
* Sun Nov 22 2015 Satoru SATOH <ssato@redhat.com> - 0.4.0-1
- fix: correct escape/unescape process in Java properties backend, closed #31
- enhancement: Added naive impl. of JSON Pointer support (getter only)
- refactor: Refactoring around backend base classes, loaders and dumpers
- some other enhancements, refactorings and bug fixes

* Tue Oct 20 2015 Satoru SATOH <ssato@redhat.com> - 0.3.0-1
- Enhance anyconfig.multiload not to resolv appropriate config parsers
  everytime loading config files
- Remove a few backend (common and specific) and common options such as merge
  (ac_merge), marker (ac_marker), etc. from definitions of some public API
  functions
- Add 'ac_' prefix to some keyword arguments to public APIs
- fix wrong definition of extensions in BSON backend
- fix a bug that ini (configparser) backend behaves different from original;
  may close #28
- fix a bug to pass extra keyword parameters to yaml.safe_load
- fix a bug that anyconfig.backend.base.LParser.load_from_string does not
  process and pass process keyword args `kwargs`
- add some more API usage code examples in the doc
- a lot of other enhancements, refactorings and bug fixes; some of them might
  break public nad internal APIs so that bumped up the version

* Mon Sep 21 2015 Satoru SATOH <ssato@redhat.com> - 0.2.2-1
- Lower the level of some warn logging messages if backend support module is
  not available
- Cleanup the doc of PyPI page
- Add logging settings in the doc

* Fri Sep 18 2015 Satoru SATOH <ssato@redhat.com> - 0.2.0-1
- new API anyconfig.to_container, factory method to create container objects
- enale processing of stream in anyconfig.*load and anyconfig.*dump
- add a native implementation of Java properties file backend
- misc doc updates about new backend, APIs, etc.
- massive refactoring of some complex modules such as api, cli, mergeabledict,
  parser and some backends and also add some more corner test cases
- some more minor possible bug fixes found by pylint and flake8

* Sat Aug 15 2015 Satoru SATOH <ssato@redhat.com> - 0.1.0-1
- add BSON support
- add TOML support
- fix XML load and dump functions
- add some more corner test cases to improve test coverage
- clean up and refactor some test cases
- clean up the RPM SPEC to sort out requirements
- make HTML doc built for fedora only
- some more minor possible bug fixes found by pylint and flake8

* Mon Aug 10 2015 Satoru SATOH <ssato@redhat.com> - 0.0.13-1
- fix up broken PyPI description page

* Mon Aug 10 2015 Satoru SATOH <ssato@redhat.com> - 0.0.12-1
- add some usage examples of the CLI frontend in the doc
- fix some trivial bugs in the CLI frontend
- make the contents of README and the doc consistent
- make the doc included in RPM packages

* Wed Aug  5 2015 Satoru SATOH <ssato@redhat.com> - 0.0.11-1
- add MessagePack load/dump support
- add new API 'gen_schema' to generate JSON schema for given configs
- fix some bugs around JSON schema validation while loading configs
- add HTML doc in a package
- simplify README.rst a lot and just left a reference to
  http://python-anyconfig.readthedocs.org provides online HTML doc
- some more minor possible bug fixes found by pylint and flake8

* Sun Jun 21 2015 Satoru SATOH <ssato@redhat.com> - 0.0.10-1
- add new API 'validate' to validate config files with json schema
- some more minor possible bug fixes found by pylint and flake8

* Sun Jun 14 2015 Satoru SATOH <ssato@redhat.com> - 0.0.9-1
- merge configobj backend
- some more minor possible bug fixes found by pylint and flake8
- minor expression updates and fixes in README.rst

* Tue May 26 2015 Satoru SATOH <ssato@redhat.com> - 0.0.8-1
- remove os.curdir from a list of default template search paths, may close #18
- remove a global, SUPPORTED and import-error hack around it completely; now
  implementation of backends are simplified a lot
- fix a lot of pylint and flake8 warnings
- some more minor bug fixes and enhancements

* Thu Apr 23 2015 Satoru SATOH <ssato@redhat.com> - 0.0.7-1
- module level logging fixes and improvements, may close issue#13 and issue#14
- export anyconfig.api.set_ to public which was not exported
- rename a few function parameters template and context passed to *load* to
  avoid conflicts with parameters intended to pass to backends
- reorder some arguments passed to anyconfig.api.*load to keep consistency in
  the order of arguments among them
- add --env option to the CLI frontend to pass configuration default values
  from envrionment variables
- some more minor bug fixes and enhancements

* Fri Mar 13 2015 Satoru SATOH <ssato@redhat.com> - 0.0.6-1
- show ini file structure erros by Kamil Chmielewski, closes PR#8
- beautify README.rst by Florian Ludwig, closes PR#10
- add support to load template config files
- removes all custom logging magic and changes the behaviour to the standard
  way of logging for Python libraries by Wouter Bolsterlee, closed PR#11
- re-enable Travis-CI tests for python 2.6
- some more minor bug fixes and enhancements

* Sun Oct 26 2014 Satoru SATOH <ssato@redhat.com> - 0.0.5-1
- start to monitor code coverage w/ using coveralls.io
- start to do extra health check by landscape.io
- introduce 'ignore_missing' optional parameter to ignore missing config
  file[s] in anyconfig.apy.*load() originally suggested by chmac in issue#4
- add -x/--ignore-missing option to allow ignoring missing files in anyconfig_cli
- make xml backend loader worked although it nees a lot more work
- fix a typo in README.rst by Jonathan Eunice, closes PR#1
- some more minor bug fixes and enhancements

* Tue Aug 19 2014 Satoru SATOH <ssato@redhat.com> - 0.0.4-1
- Change the versioning scheme and bump up the version to fix the issue #3

* Fri Aug  1 2014 Satoru SATOH <ssato@redhat.com> - 0.0.3.13-1
- Enable flake8 (pyFlake + pep8) testing
- Fix some minor errors like F401 (import-but-not-used eror) found by flake8
- Introduce an environment variable ANYCONFIG_DEBUG to control module's log
  level from outside world
- Add anyconfig.getset module and --get option to anyconfig cli frontend to get
  (extract) partial configuration[s] from loaded config files
- Add python 3.4 support and also make it tested in CI process

* Sat May  3 2014 Satoru SATOH <ssato@redhat.com> - 0.0.3.12-1
- Support safe_{load,dump} in YAML backend by safe=True argument
- Add some more keyword arguments support in JSON backend
- Add man page of anyconfig_cli
- Misc fixes and enhancements in anyconfig_cli
- Some PEP8 and pylint errors and warnings
- Fix some rpmlint errors

* Fri Jan 10 2014 Satoru SATOH <ssato@redhat.com> - 0.0.3.11-1
- Just a maintenance update release
- Add pylint checks and refactor test driver script
- Fix some PEP8 and pylint errors and warnings

* Thu May  2 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.10-1
- [anyconfig_cli] Fix a typo in its filename; s/anyconfg/anyconfig/g,
  it's alsot pointed by jonathaneunice-san. Thanks a lot!
- Swtich to use setuptools instead of standard distutils to allow writing
  various pluggable backends
- Implement pluggable backend system w/ using setuptools
- Fix some build and runtime dependencies to PyYAML and setuptools
- Spin off java properties file backend into a separate project:
  https://github.com/ssato/python-anyconfig-pyjavaproperties-backend
- Fix some type mismatches in methods of backend modules
- Make cli frontend generated w/ setuptools' help and remove tools/*

* Sun Mar 31 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.9-1
- Some fixes and enhancements around logging code
- [anyconfig_cli] add -s/--silent and -v/--verbose option to control log level
  and removed -d/--debug option
- Allow swtich from/to build time snapshot-versioning-mode dynamically
- Build also RPMs for python-3.x
- Allow backend specific options passed to load*/dump* methods of some backends
- Ensure dir to dump output created if that dir not exist

* Wed Mar 13 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.8-1
- Do not expose internal repr. of loaded data when dump them
- Fix for ini (configparser) backend

* Tue Mar 12 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.7-1
- change API from anyconfig.find_parser to anyconfig.find_loader
- [anyconfig_cli] rename cli frontend from anyconfig_cui to anyconfig_cli
- [anyconfig_cli] add new option '-M/--merge' to select strategy to merge
  multiple configs
- add 'noreplace' merging strategy
- fix the bug that 'replace' merge strategy (value: 0) was evaluated as False
  and cause an 'invalid strategy' error, and change default merging strategy
- other misc fixes for PEP8 errors and warns, etc.

* Fri Feb  1 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.6-1
- Added -A and --atype option to anyconfig_cui to override configs w/ -A option
- Fixed an error in anyconfig.api.loads when config type is None
- Updated usage example of anyconfig_cui in README

* Fri Jan 18 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.5-1
- Changed the default merge strategy of anyconfig.mergeabledict.MergeableDict
  from merge_dicts_and_lists to merge_dicts
- Updated README and added some usage examples

* Thu Jan 17 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.4-1
- Fine tunes in some APIs to load multi config files
- Updated and enhanced CUI frontend, anyconfig_cui
- Fixed a bug in anyconfig.Bunch.update_w_merge that cause error when merging
  lists with passing merge_lists=True argument
- Updated module's doctext and added some usage examples
- Removed strong dependency to anyconfig.Bunch.Bunch, and switched to
  anyconfig.mergeabledict.MergeableDict which is stripped-down version of
  anyconfig.Bunch.Bunch object

* Fri Jan  4 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.3-1
- Changed APIs (new: load, {single,mulit}_load) and some cleanups
- Complemented some meta package info to register this module to PyPI
- Changed the name of python module; stripped 'python-' from its name

* Fri Jan  4 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.2-1
- Fixed a few that yaml.* and etree.* not defined when yaml and etree module is
  not found, causing build time error

* Fri Jan  4 2013 Satoru SATOH <ssato@redhat.com> - 0.0.3.1-1
- Added metaconfig module to control config-loading behavior
- Added some new APIs including anyconfig.{mload,loads}, etc.
- Started CI tests w/ Travis

* Sat Aug  4 2012 Satoru SATOH <ssato@redhat.com> - 0.0.3-1
- Fixed a grave syntax error in anyconfig.backend.properties_
- Some docstring cleanups
- Some refactoring
- Implemented dicts merge/replacements came from config files

* Mon Jul  2 2012 Satoru SATOH <ssato@redhat.com> - 0.0.2-1
- Fixed packaging bug that some modules were missing from the list

* Fri Jun 29 2012 Satoru SATOH <ssato@redhat.com> - 0.0.1-1
- Initial packaging
